/*   DirectDraw ⏕NX  Ver 0.20   */
/*                                     */
/*                                     */
/*   by Atsushi             1999/9/7   */


class DirectDrawAssistant:public Object
{
private:
	IDirectDrawSurface7* surface;
	
	DDSURFACEDESC2 desc;
	
	DWORD* tableR;
	DWORD* tableG;
	DWORD* tableB;
	int shiftR,shiftG,shiftB;
	int scaleR,scaleG,scaleB;
	
	void init(void);

public:
	DirectDrawAssistant(IDirectDrawSurface7* surface);
	~DirectDrawAssistant(void);
	
	virtual void lock(void);
	virtual void lock(DWORD flag);
	virtual void unlock(void);
	virtual DWORD getPixel(int x,int y);
	virtual void setPixel(int x,int y,DWORD rgb);
	
	virtual int getWidth(void);
	virtual int getHeight(void);
	
	virtual DWORD* getRedToPixel(void);
	virtual DWORD* getGreenToPixel(void);
	virtual DWORD* getBlueToPixel(void);
	
	virtual int getRedShift(void);
	virtual int getGreenShift(void);
	virtual int getBlueShift(void);
	
	virtual int getRedScale(void);
	virtual int getGreenScale(void);
	virtual int getBlueScale(void);
	
	virtual DWORD getRedMask(void);
	virtual DWORD getGreenMask(void);
	virtual DWORD getBlueMask(void);
	
	virtual IDirectDrawSurface7* getSurface(void);
	virtual DDSURFACEDESC2 getSurfaceDesc(void);
};
