/*   X File ǂݍ  Ver 0.60   */
/*                               */
/*                               */
/*   by Atsushi     1999/10/20   */


class XFileObjectNode;
class BoundingSphere;
class BoundingBox;
class TransformMatrix;
class Vector3;


class XFileObject:public Object
{
private:
	XFileObjectNode* shapeTree;

public:
	XFileObject(XFileObjectNode* shapeTree);
	~XFileObject(void);
	
	virtual void paint(IDirect3DDevice7* device);
	
	virtual XFileObjectNode* getTree(void);
	virtual XFileObjectNode* getNode(String* name);
	virtual void detachNode(String* name);
	
	virtual BoundingSphere* getBoundingSphere(void);
	virtual BoundingBox* getBoundingBox(void);
	
	virtual Vector3** getVertices(void);
	virtual TransformMatrix* getTransformMatrix(String* name);
	
	virtual void setAlpha(int value);
};
