/*   X File ǂݍ  Ver 0.60   */
/*                               */
/*                               */
/*   by Atsushi     1999/10/20   */


class TransformMatrix;
class Vector3;
class XFileObjectNode;


class XFileObjectFrame:public XFileObjectNode
{
private:
	D3DMATRIX matrix;

public:
	XFileObjectFrame(String* name);
	~XFileObjectFrame(void);
	
	virtual void paint(IDirect3DDevice7* device);
	
	virtual void setMatrix(D3DMATRIX matrix);
	virtual TransformMatrix* getTransformMatrix(void);
	
	virtual XFileObjectNode* getChild(int index);
	
	virtual void computeBoundingSphereCenter(TransformMatrix* matrix,
	                                         D3DVECTOR* center,
	                                         int* pointLength);
	virtual void computeBoundingSphereRadius(TransformMatrix* matrix,
	                                         D3DVECTOR* center,
	                                         D3DVALUE* radius);
	
	virtual Vector3** getVertices(TransformMatrix* transform);
	virtual TransformMatrix* getTransformMatrix(String* name);
};
