/*   X File ǂݍ  Ver 0.60   */
/*                               */
/*                               */
/*   by Atsushi     1999/10/20   */


class TransformMatrix;
class Vector3;


class XFileObjectNode:public Object
{
protected:
	XFileObjectNode* next;
	XFileObjectNode* child;
	
	String* name;
	
	XFileObjectNode(String* name);

public:
	~XFileObjectNode(void);
	
	virtual void addNext(XFileObjectNode* node);
	virtual void addChild(XFileObjectNode* node);
	virtual XFileObjectNode* getNext(void);
	
	virtual void paint(IDirect3DDevice7* device)=0;
	
	virtual String* getName(void);
	
	virtual XFileObjectNode* getNode(String* name);
	virtual void detachNode(String* name);
	
	virtual void computeBoundingSphereCenter(TransformMatrix* matrix,
	                                         D3DVECTOR* center,
	                                         int* pointLength);
	virtual void computeBoundingSphereRadius(TransformMatrix* matrix,
	                                         D3DVECTOR* center,
	                                         D3DVALUE* radius);
	
	virtual Vector3** getVertices(TransformMatrix* transform)=0;
	virtual TransformMatrix* getTransformMatrix(String* name)=0;
};
