/*   DialogBox NX  Ver 0.00   */
/*                                */
/*                                */
/*   by Atsushi       1999/5/11   */


class DialogListener;
class EventListenerContainer;
class GUI;


class Dialog:public GUI
{
private:
	static Dialog* first;
	Dialog* next;
	
	EventListenerContainer<DialogListener>* listeners;
	
	boolean fireDialogMessageSent(HWND dialog,UINT message,
	                              WPARAM wParam,LPARAM lParam);

protected:
	Dialog(void);
	~Dialog(void);
	
	static Dialog* active;
	
	virtual BOOL DialogProc(UINT message,WPARAM wParam,LPARAM lParam)=0;

public:
	static BOOL CALLBACK DialogProc(HWND dialog,UINT message,
	                                WPARAM wParam,LPARAM lParam);
	
	virtual boolean isShowing();
	
	virtual String* getItemText(int id);
	virtual void setItemText(int id,String* text);
	
	virtual void addStringToComboBox(int id,String* text);
	
	virtual void addDialogListener(DialogListener* listener);
	virtual void removeDialogListener(DialogListener* listener);
};
