/*   Dialog NX  Ver 0.00   */
/*                             */
/*                             */
/*   by Atsushi    1999/5/11   */


#include "basic.h"

#include "GUI.h"
#include "lib/util/Enumeration.h"
#include "lib/event/EventListener.h"
#include "lib/event/EventListenerEnumeration.h"
#include "lib/event/EventListenerContainer.h"
#include "Dialog.h"
#include "ModalDialogBox.h"


/*   ---   RXgN^   ---   */

ModalDialogBox::ModalDialogBox(HINSTANCE hInstance,WORD id,GUI* parent)
               :Dialog()
{
	this->hInstance=hInstance;
	this->id       =id;
	this->parent   =parent;
}


/*   ---   \   ---   */

void ModalDialogBox::show(void)
{
	active=this;
	DialogBox(hInstance,MAKEINTRESOURCE(id),
	          parent->getHandle(),Dialog::DialogProc);
	active=NULL;
}

void ModalDialogBox::hide(void)
{
	EndDialog(handle,0);
	handle=NULL;
}


/*   ---   Cxg   ---   */

BOOL ModalDialogBox::DialogProc(UINT message,WPARAM wParam,LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		setFocus();
		return 0;
	}
	
	return 0;
}


/*   ---   fXgN^   ---   */

ModalDialogBox::~ModalDialogBox(void)
{
}
