/*   Window NX  Ver 0.20   */
/*                             */
/*                             */
/*   by Atsushi    1999/5/11   */


class WindowListener;
template <class Listener> class EventListenerContainer;


class Window:public GUI
{
private:
	static Window* first;
	Window* next;
	
	EventListenerContainer<WindowListener>* listeners;
	
	void fireWindowMessageSent(HWND window,UINT message,
	                           WPARAM wParam,LPARAM lParam);

protected:
	static Window* active;

public:
	Window(void);
	~Window(void);
	
	static LRESULT CALLBACK WindowProc(HWND window,UINT message,
	                                   WPARAM wParam,LPARAM lParam);
	virtual LRESULT WindowProc(UINT message,WPARAM wParam,LPARAM lParam)=0;
	
	virtual void addWindowListener(WindowListener* listener);
	virtual void removeWindowListener(WindowListener* listener);
};
