/*   Ë ()  Ver 0.00   */
/*                             */
/*                             */
/*   by Atsushi     1999/8/3   */


class Vector3;
class BoundingSphere;
class Bounds;


class BoundingBox:public Bounds
{
private:
	D3DVALUE minX,minY,minZ;
	D3DVALUE maxX,maxY,maxZ;

public:
	BoundingBox(D3DVALUE minX,D3DVALUE minY,D3DVALUE minZ,
	            D3DVALUE maxX,D3DVALUE maxY,D3DVALUE maxZ);
	BoundingBox(BoundingBox* box);
	BoundingBox(void);
	~BoundingBox(void);
	
	static void* operator new(size_t size);
	static void operator delete(void *object);
	
	virtual D3DVALUE getMinX(void);
	virtual D3DVALUE getMinY(void);
	virtual D3DVALUE getMinZ(void);
	virtual D3DVALUE getMaxX(void);
	virtual D3DVALUE getMaxY(void);
	virtual D3DVALUE getMaxZ(void);
	
	virtual void set(D3DVALUE minX,D3DVALUE minY,D3DVALUE minZ,
	                 D3DVALUE maxX,D3DVALUE maxY,D3DVALUE maxZ);
	
	virtual boolean intersects(BoundingBox* target);
	virtual boolean intersects(BoundingSphere* target);
	virtual boolean contains(Vector3* target);
	
	virtual void translate(Vector3* delta);
};
