/*   Ë ()  Ver 0.30   */
/*                             */
/*                             */
/*   by Atsushi    1999/8/22   */


class Vector3;
class Bounds;


class BoundingSphere:public Bounds
{
private:
	Vector3* center;
	D3DVALUE radius;

public:
	BoundingSphere(Vector3* center,D3DVALUE radius);
	BoundingSphere(BoundingSphere* bounds);
	BoundingSphere(void);
	~BoundingSphere(void);
	
	static void* operator new(size_t size);
	static void operator delete(void *object);
	
	virtual Vector3* getCenter(void);
	virtual D3DVALUE getRadius(void);
	
	virtual void set(BoundingSphere* bounds);
	virtual void setCenter(Vector3* center);
	virtual void setRadius(D3DVALUE radius);
	
	virtual boolean intersects(BoundingSphere* target);
	virtual boolean contains(Vector3* target);
	
	virtual void translate(Vector3* delta);
};
