/*   4 s 4 s  Ver 0.30   */
/*                             */
/*                             */
/*   by Atsushi   1999/10/21   */


class Vector3;
class Quaternion;


class Matrix4:public Object
{
protected:
	D3DXMATRIX matrix;

public:
	Matrix4(D3DMATRIX matrix);
	Matrix4(Matrix4* matrix);
	Matrix4(void);
	~Matrix4(void);
	
	static void* operator new(size_t size);
	static void operator delete(void *object);
	
	virtual D3DMATRIX* getMatrix(void);
	virtual D3DXMATRIX* getDXMatrix(void);
	virtual float get(int y,int x);
	
	virtual boolean isIdentity(void);
	
	virtual void set(Matrix4* matrix);
	virtual void set(int y,int x,float value);
	virtual void setZero(void);
	virtual void setIdentity(void);
	
	virtual void setInverse(Matrix4* value);
	virtual void setMultiplication(Matrix4* multiplicand,
	                               Matrix4* multiplier);
	
	virtual Matrix4* multiply(Matrix4* multiplier);
	virtual Matrix4* operator*(Matrix4 multiplier);
	
	virtual Matrix4* inverse(void);
};
