/*   InetAddress NX  Ver 0.10   */
/*                                  */
/*                                  */
/*   by toyo    1999/4/29           */

class Socket;
class DatagramPacket;
class InetAddressManager;
class NetworkException;

class InetAddress:public Object{
private:
	LPSOCKADDR_IN lpSocketAddress;
	String *hostName;
	
	InetAddress(LPSOCKADDR_IN);
	InetAddress(LPSOCKADDR_IN,String *);
	friend class Socket;
	friend class DatagramSocket;
	friend class DatagramPacket;
	friend class InetAddressManager;
public:
	virtual ~InetAddress(void);
	
	virtual InetAddress* clone(void);
	virtual BYTE* getAddress(void);
	virtual String* getHostAddress(void);
	virtual String* getHostName() throw (NetworkException*);
	
	//̊֐̓ubN̂ŁAInetAddressManager NXg
	//InetAddress ͎擾B
	static InetAddress* getByName(String*) throw (NetworkException*);
	static InetAddress** getAllByName(String*) throw (NetworkException*);
	static InetAddress* getLocalHost() throw (NetworkException*);
};

