/*   URL NX  Ver 0.10   */
/*                          */
/*                          */
/*   by Atsushi  1999/8/6   */


#include "basic.h"

#include "URL.h"


/*   ---   RXgN^   ---   */

URL::URL(String* protocol,String* host,int port,String* file)
{
	this->protocol=protocol;
	this->host    =host;
	this->port    =port;
	this->file    =file;
}


/*   ---      ---   */

String* URL::getProtocol(void)
{
	return protocol;
}

String* URL::getHost(void)
{
	return host;
}

int URL::getPort(void)
{
	return port;
}

String* URL::getFile(void)
{
	return file;
}


/*   ---      ---   */

String* URL::toExternalForm(void)
{
	return String::format("%s://%s:%u/%s",
	    protocol->toCharArray(),host->toCharArray(),port,
	    (file==NULL ? "" : file->toCharArray()));
}

String* URL::toString(void)
{
	return toExternalForm();
}


/*   ---   fXgN^   ---   */

URL::~URL(void)
{
	if (protocol!=NULL) delete protocol;
	if (host    !=NULL) delete host;
	if (file    !=NULL) delete file;
}
