/*	 MidiPlayer NX		Ver 0.00 */
/*									*/
/*									*/
/*	 by toyo		1999/7/31		*/

class String;
class MidiData;
class DirectSoundManager;
class Vector3;

class MidiPlayer:public Object{
private:
	DirectSoundManager *directSoundManager;

	IDirectMusic *lpDirectMusic;

	IDirectMusicLoader *lpDirectMusicLoader;
	IDirectMusicPerformance *lpDirectMusicPerformance;
	IDirectMusicPort *lpDirectMusicPort;
	
	LPDIRECTSOUNDBUFFER lpDirectSoundBuffer;
	LPDIRECTSOUND3DBUFFER lpDirectSound3DBuffer;
	
	virtual void init(void);
	virtual void initDirectMusicLoader(void);
	virtual void initDirectMusicPerformance(void);
	virtual void initDirectMusicPort(void);
	
	boolean playing;
	long defaultVolume;
public:
	MidiPlayer(DirectSoundManager *directSoundManager);
	~MidiPlayer(void);
	
	virtual void play(MidiData *midiData);
	virtual void play(MidiData *midiData,boolean isLoop);
	virtual void play(MidiData *midiData,DWORD times);

	virtual void stop();
	virtual boolean isPlaying();
	virtual void setVolume(long volume);
	
	virtual void setMode(DWORD mode);

	virtual MidiData* readMidiData(String *path,String *fileName);
	virtual void setPosition(Vector3 *position);
	virtual void setVelocity(Vector3 *velocity);
	virtual void setOrientation(Vector3 *direction);
};

