/* SoundBuffer NX  Ver 0.00   */
/*                                */
/*                                */
/*   by toyo    1999/4/8          */

class Serializable;
class ObjectInputStream;
class ObjectOutputStream;

class SoundBuffer:public Object,public Serializable{
private:
	char *buffer;
	int bufferSize;
	 
	int blockSize;
	int blockNum;
public:
	SoundBuffer(void);
	SoundBuffer(int blockSize,int blockNum);
	SoundBuffer(char *buffer,int blockSize,int blockNum);
	~SoundBuffer();
	
	SoundBuffer* clone();
	char* getBuffer();
	char* getBlock(int blockNo);
	int getBlockNum();
	int getBlockSize();
	int getBufferSize();
	
	void setBuffer(char *buffer);
	void setBlockNum(int blockNum);
	void setBlockSize(int blockSize);
	void setBufferSize(int bufferSize);

	static SoundBuffer* newInstance(int id);
	virtual int getTypeID(void);
	virtual void readObject(ObjectInputStream* in);
	virtual void writeObject(ObjectOutputStream* out);
};

