/*	 SoundData3D NX		Ver 0.00 */
/*									 */
/*									 */
/*	 by toyo		1999/5/16		 */

class SoundBuffer;
class SoundData;
class WaveFormat;
class Vector3;

class SoundData3D:public SoundData{
public:
	//DS3DBUFFER desc3DBuffer;
	LPDIRECTSOUND3DBUFFER *lpDirectSound3DBuffer;
	
	SoundData3D(void);

	SoundData3D(SoundData *soundData);
	
	SoundData3D(
		SoundBuffer *soundBuffer,
		WaveFormat *waveFormat
	);
	
	Vector3 **position;
	Vector3 **velocity;
	Vector3 **orientation;
	
	boolean *isPositionValid;
	boolean *isVelocityValid;
	boolean *isOrientationValid;

	~SoundData3D(void);
	//virtual DS3DBUFFER getDS3DBUFFER(void);
	//virtual void setDS3DBUFFER(DS3DBUFFER desc3DBuffer);
	
	virtual LPDIRECTSOUND3DBUFFER getDirectSound3DBuffer();
	virtual void setDirectSound3DBuffer(LPDIRECTSOUND3DBUFFER lpDirectSound3DBuffer);
	virtual LPDIRECTSOUND3DBUFFER getDirectSound3DBuffer(int index);
	virtual void setDirectSound3DBuffer(LPDIRECTSOUND3DBUFFER lpDirectSound3DBuffer,int index);
	
	virtual void setConeAngles(DWORD dwInsideConeAngle,DWORD dwOutsideConeAngle);
	virtual void setConeOutsideVolume(long lConeOutsideVolume);
	virtual void setMaxDistance(D3DVALUE flMaxDistance);
	virtual void setMinDistance(D3DVALUE flMinDistance);
	virtual void setMode(DWORD dwMode);
	
	virtual void setPosition(Vector3 *position);//
	virtual void setVelocity(Vector3 *velocity);//
	virtual void setConeOrientation(Vector3 *orientation);//
	
	virtual void setPosition(Vector3 *position,int index);//
	virtual void setVelocity(Vector3 *velocity,int index);//
	virtual void setConeOrientation(Vector3 *orientation,int index);//
		
	virtual void setPositionSub(Vector3 *position,int index);//
	virtual void setVelocitySub(Vector3 *velocity,int index);//
	virtual void setConeOrientationSub(Vector3 *orientation,int index);//

	virtual void validateSettings();
	virtual void validateSettings(int index);
};

