/*   IuWFNg\z   Ver 0.20   */
/*                                       */
/*                                       */
/*   by Atsushi             1999/11/23   */


/*   ---   RXgN^   ---   */

template <class Type> ObjectPool<Type>::ObjectPool(void)
{
}


/*   ---   v[   ---   */

template <class Type> void ObjectPool<Type>::newPool(int length)
{
	PooledObject<Type>* newObject;

	for (int i=0;i<=length-1;i++)
	{
		newObject=(PooledObject<Type>*)(malloc(sizeof(PooledObject<Type>)));
		newObject->next=PooledObject<Type>::first;
		PooledObject<Type>::first=newObject;
	}
}

template <class Type> void ObjectPool<Type>::deletePool(void)
{
	PooledObject<Type>* nextObject;

	for (PooledObject<Type>* temp=PooledObject<Type>::first;
	     temp!=NULL;temp=nextObject)
	{
		nextObject=temp->next;
		
		free(temp);
	}
}


/*   ---   new / delete   ---   */

template <class Type> Type* ObjectPool<Type>::newObject(void)
{
	Type* thisObject;

	if (PooledObject<Type>::first==NULL)
	{
		throw new OutOfPoolException(
		    new String((char*)(typeid(Type).name())+6));
	}
	
	thisObject=(Type*)(PooledObject<Type>::first);
	PooledObject<Type>::first=PooledObject<Type>::first->next;
	
	return thisObject;
}

template <class Type> void ObjectPool<Type>::deleteObject(Type* object)
{
	PooledObject<Type>* thisObject;

	thisObject=(PooledObject<Type>*)(object);
	
	thisObject->next=PooledObject<Type>::first;
	PooledObject<Type>::first=thisObject;
}


/*   ---   fXgN^   ---   */

template <class Type> ObjectPool<Type>::~ObjectPool(void)
{
}
