/*   ϒz   Ver 0.40   */
/*                           */
/*                           */
/*   by Atsushi  1999/9/12   */


/*   ---   RXgN^   ---   */

template <class Type> Vector<Type>::Vector(void)
{
	capacity=1;
	elements=new Type*[capacity];
	size=0;
}


/*   ---   Q   ---   */

template <class Type> Type* Vector<Type>::getElement(int index)
{
	return elements[index];
}

template <class Type> int Vector<Type>::getSize(void)
{
	return size;
}


/*   ---      ---   */

template <class Type> void Vector<Type>::clear(void)
{
	size=0;
}

template <class Type> void Vector<Type>::deleteAll(void)
{
	for (int i=0;i<=size-1;i++)
	{
		delete elements[i];
	}
	
	clear();
}


/*   ---   ǉE폜   ---   */

template <class Type> void Vector<Type>::addElement(Type* value)
{
	Type** old;

	if (size==capacity)
	{
		old=elements;
		capacity*=2;
		
		elements=new Type*[capacity];
		for (int i=0;i<=size-1;i++)
		{
			elements[i]=old[i];
		}
		
		delete[] old;
	}
	
	elements[size]=value;
	
	size++;
}

template <class Type> void Vector<Type>::removeElement(Type* value)
{
	int k;

	k=0;
	while (k<=size-1 && elements[k]!=value) k++;
	
	if (k==size) return;
	
	for (int i=k;i<=size-1;i++)
	{
		elements[i]=elements[i+1];
	}
	
	size--;
}


/*   ---   fXgN^   ---   */

template <class Type> Vector<Type>::~Vector(void)
{
	delete[] elements;
}
