/*   X File ǂݍ  Ver 0.50   */
/*                               */
/*                               */
/*   by Atsushi       1999/9/9   */


template <class KeyType,class ValueType> class Hashtable;
class TransformMatrix;
class XFileObjectNode;
class XFileObjectMesh;
class XFileObject;


class CompiledXFileObject:public XFileObject
{
private:
	XFileObjectMesh** shapeMeshes;
	int shapeMeshLength;
	
	Hashtable<String,TransformMatrix>* pointCache;

public:
	CompiledXFileObject(XFileObjectNode* shapeTree,
	                    XFileObjectMesh** shapeMeshes,
	                    int shapeMeshLength);
	~CompiledXFileObject(void);
	
	virtual void paint(IDirect3DDevice7* device);
	
	virtual void detachNode(String* name);
	
	virtual TransformMatrix* getTransformMatrix(String* name);
	
	virtual void setAlpha(int value);
	
	virtual void setCompiledData(XFileObjectMesh** shapeMeshes,
	                             int shapeMeshLength);
};
