/*   Alignment w摜`  Ver 0.00   */
/*                                      */
/*                                      */
/*   by Atsushi             1999/8/29   */


class Stamp:public Object
{
public:
	static const double ALIGN_LEFT;
	static const double ALIGN_RIGHT;
	static const double ALIGN_CENTER;
	static const double ALIGN_TOP;
	static const double ALIGN_BOTTOM;

private:
	IDirectDrawSurface7* image;
	boolean transparency;
	int width,height;
	
	double alignX,alignY;
	
	void init(void);

public:
	Stamp(IDirectDrawSurface7* image,boolean transparency);
	Stamp(IDirectDrawSurface7* image);
	~Stamp(void);
	
	virtual int getWidth(void);
	virtual int getHeight(void);
	
	virtual void setAlignment(double alignX,double alignY);
	virtual void paint(IDirectDrawSurface7* target,int x,int y);
};
