/*   eNX`[ǂݍ  Ver 0.60   */
/*                                    */
/*                                    */
/*   by Atsushi          1999/11/23   */


class ImageLoader;


class TextureLoader:public Object
{
private:
	typedef struct {
		boolean bit[32];
		DDPIXELFORMAT validFormat;
		int priority;
	} TEXTURE_FORMAT;
	
	IDirectDraw7* ddraw;
	IDirect3DDevice7* device;
	HINSTANCE hInstance;
	
	TEXTURE_FORMAT format;
	ImageLoader* imageLoader;
	
	void init(void);
	
	IDirectDrawSurface7* load(IDirectDrawSurface7* image0);
	IDirectDrawSurface7* load(IDirectDrawSurface7** image0,int length);

public:
	TextureLoader(IDirectDraw7* ddraw,IDirect3DDevice7* device,
	              HINSTANCE hInstance);
	~TextureLoader(void);
	
	static HRESULT CALLBACK D3DEnumPixelFormatsCallback(
	    DDPIXELFORMAT* pixelFormat,VOID* userData);
	
	virtual IDirectDrawSurface7* load(WORD resource);
	virtual IDirectDrawSurface7* load(String* filename);
	virtual IDirectDrawSurface7* load(char* filename);
	
	virtual IDirectDrawSurface7* load(WORD resource,DDCOLORKEY colorKey);
	virtual IDirectDrawSurface7* load(String* filename,DDCOLORKEY colorKey);
	virtual IDirectDrawSurface7* load(char* filename,DDCOLORKEY colorKey);
	
	virtual IDirectDrawSurface7* load(WORD* resource,int length);
	virtual IDirectDrawSurface7* load(String** filename,int length);
	virtual IDirectDrawSurface7* load(char** filename,int length);
	
	virtual IDirectDrawSurface7* load(WORD* resource,int length,
	                                  DDCOLORKEY colorKey);
	virtual IDirectDrawSurface7* load(String** filename,int length,
	                                  DDCOLORKEY colorKey);
	virtual IDirectDrawSurface7* load(char** filename,int length,
	                                  DDCOLORKEY colorKey);
};
