/*   X File ǂݍ  Ver 0.60   */
/*                               */
/*                               */
/*   by Atsushi     1999/10/20   */


template <class Type> class Vector;
class TransformMatrix;
class XFileObjectMesh;
class XFileObjectFrame;
class XFileObject;
class CompiledXFileObject;


class XFileObjectCompiler:public Object
{
private:
	Vector<XFileObjectMesh>* meshes;
	
	void compileObject(XFileObject* object);
	
	void convertNode(XFileObjectNode* node,TransformMatrix* transform);
	void convertNode(XFileObjectMesh* node,TransformMatrix* transform);
	void convertNode(XFileObjectFrame* node,TransformMatrix* transform);
	
	boolean canCombine(XFileObjectMesh* mesh1,XFileObjectMesh* mesh2);
	XFileObjectMesh* combineMeshes(XFileObjectMesh* mesh1,
	                               XFileObjectMesh* mesh2);

public:
	XFileObjectCompiler(void);
	~XFileObjectCompiler(void);
	
	virtual XFileObject* compile(XFileObject* object);
	virtual void recompile(CompiledXFileObject* object);
};
