/*   Cxg  Ver 0.10   */
/*                            */
/*                            */
/*   by Atsushi   1999/5/16   */


/*   ---   RXgN^   ---   */

template <class Listener> EventListenerContainer<Listener>
                        ::EventListenerContainer(void)
{
	capacity=1;
	listeners=new Listener*[capacity];
	size=0;
}


/*   ---   o^E폜   ---   */

template <class Listener> void EventListenerContainer<Listener>
                               ::addEventListener(Listener* listener)
{
	Listener** old;

	if (size==capacity)
	{
		old=listeners;
		capacity*=2;
		
		listeners=new Listener*[capacity];
		for (int i=0;i<=size-1;i++)
		{
			listeners[i]=old[i];
		}
		
		delete old;
	}
	
	listeners[size]=listener;
	
	size++;
}

template <class Listener> void EventListenerContainer<Listener>
                               ::removeEventListener(Listener* listener)
{
	int a;

	a=0;
	for (int i=0;i<=size-1;i++)
	{
		if (listeners[i]==listener)
		{
			a++;
			size--;
		}
		
		listeners[i]=listeners[i+a];
	}
}


/*   ---   g   ---   */

template <class Listener> EventListenerEnumeration<Listener>*
                          EventListenerContainer<Listener>
                          ::getEventListeners(void)
{
	return new EventListenerEnumeration<Listener>(listeners,size);
}


/*   ---   fXgN^   ---   */

template <class Listener> EventListenerContainer<Listener>
                          ::~EventListenerContainer(void)
{
	delete listeners;
}
