/*   Dialog NX  Ver 0.00   */
/*                             */
/*                             */
/*   by Atsushi    1999/5/11   */


#include "basic.h"

#include "GUI.h"
#include "lib/util/Enumeration.h"
#include "lib/event/EventListener.h"
#include "lib/event/EventListenerEnumeration.h"
#include "lib/event/EventListenerContainer.h"
#include "Dialog.h"
#include "ModelessDialogBox.h"


/*   ---   RXgN^   ---   */

ModelessDialogBox::ModelessDialogBox(HINSTANCE hInstance,WORD id,GUI* parent)
                  :Dialog()
{
	this->hInstance=hInstance;
	this->id       =id;
	this->parent   =parent;
}


/*   ---   \   ---   */

void ModelessDialogBox::show(void)
{
	active=this;
	handle=CreateDialog(hInstance,MAKEINTRESOURCE(id),
	                    parent->getHandle(),Dialog::DialogProc);
	active=NULL;
	
	Dialog::show();
}

void ModelessDialogBox::hide(void)
{
	Dialog::hide();
	
	DestroyWindow(handle);
	handle=NULL;
}


/*   ---   Cxg   ---   */

BOOL ModelessDialogBox::DialogProc(UINT message,WPARAM wParam,LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		setFocus();
		return 0;
	}
	
	return 0;
}


/*   ---   fXgN^   ---   */

ModelessDialogBox::~ModelessDialogBox(void)
{
}
