/*   fobOpNX  Ver 0.20   */
/*                                */
/*                                */
/*   by Atsushi       1999/4/26   */


#define DEBUG(value) Debugger::println(value)
#define DEBUG_LINE() Debugger::printLine(__FILE__,__LINE__)
#define DEBUG_TIME() Debugger::printTime()
#define DEBUG_DDRAW(value) Debugger::printErrorDDraw(value)
#define DEBUG_D3D(value) Debugger::printErrorD3D(value)
#define DEBUG_DINPUT(value) Debugger::printErrorDInput(value)
#define DEBUG_DSOUND(value) Debugger::printErrorDSound(value)
#define DEBUG_DMUSIC(value) Debugger::printErrorDMusic(value)
#define DEBUG_DXFILE(value) Debugger::printErrorDXFile(value)

extern clock_t _time;
extern boolean _time_flag;

#define DEBUG_SPEED \
    for (_time=clock(),_time_flag=FALSE; \
         _time_flag==FALSE; \
         Debugger::println(clock()-_time),_time_flag=TRUE)


class Debugger:public Object
{
private:
	Debugger();

public:
	static void println(boolean value);
	static void println(short value);
	static void println(int value);
	static void println(long value);
	static void println(float value);
	static void println(double value);
	static void println(char* value);
	static void println(unsigned short value);
	static void println(unsigned int value);
	static void println(unsigned long value);
	static void println(void* value);
	static void println(Exception* value);
	static void println(String* value);
	static void println(Object* value);
	
	static void printLine(char* file,int line);
	static void printTime(void);
	
	static void printErrorDDraw(HRESULT value);
	static void printErrorD3D(HRESULT value);
	static void printErrorDInput(HRESULT value);
	static void printErrorDSound(HRESULT value);
	static void printErrorDMusic(HRESULT value);
	static void printErrorDXFile(HRESULT value);
};
