/*   NX  Ver 0.20   */
/*                            */
/*                            */
/*   by Atsushi   1999/8/13   */


class String:public Object,public Immutable
{
private:
	char* string;
	boolean mustDelete;

public:
	String(char* string);
	String(char* string,boolean mustDelete);
	String(String* string);
	~String(void);
	
	virtual int length(void);
	virtual char* toCharArray(void);
	virtual char charAt(int index);
	
	virtual boolean equals(String* target);
	virtual boolean equals(char* target);
	virtual boolean equalsIgnoreCase(String* target);
	virtual boolean equalsIgnoreCase(char* target);
	virtual boolean startsWith(String* target);
	virtual boolean startsWith(char* target);
	virtual boolean endsWith(String* target);
	virtual boolean endsWith(char* target);
	
	virtual String* concat(String* addend);
	virtual String* operator+(String addend);
	
	virtual String* substring(int begin,int end);
	virtual String* trim(void);
	
	virtual int indexOf(char c);
	virtual int lastIndexOf(char c);
	
	virtual int toInteger(void);
	virtual double toDouble(void);
	
	static String* valueOf(int value);
	static String* valueOf(double value);
	
	static String* format(char* format,...);
	
	virtual int getHashCode(void);
};
