/*   2 xNg  Ver 0.20   */
/*                              */
/*                              */
/*   by Atsushi    1999/12/20   */


class Vector2:public Object
{
private:
	D3DXVECTOR2 vector;

public:
	Vector2(float x,float y);
	Vector2(Vector2* vector);
	Vector2(void);
	~Vector2(void);
	
	static void* operator new(size_t size);
	static void operator delete(void *object);
	
	virtual D3DXVECTOR2* getDXVector(void);
	virtual float getX(void);
	virtual float getY(void);
	virtual boolean isZero(void);
	
	virtual void set(Vector2* vector);
	virtual void set(float x,float y);
	virtual void setZero(void);
	
	virtual void setAddition(Vector2* value,Vector2* addend);
	virtual void setSubtraction(Vector2* value0,Vector2* value1);
	virtual void setMultiplication(float multiplier);
	virtual void setNormalize(void);
	virtual void setInterpolation(Vector2* v1,Vector2* v2,double blend);
	virtual void setBaryCentric(Vector2* v1,Vector2* v2,Vector2* v3,
	                            float weight2,float weight3);
	
	virtual float getLength(void);
	virtual float getLength2(void);
	virtual double getAngle(Vector2* target);
	
	virtual Vector2* add(Vector2* addend);
	virtual Vector2* operator+(Vector2 addend);
	
	virtual Vector2* subtract(Vector2* value1);
	virtual Vector2* operator-(Vector2 value1);
	
	virtual float dot(Vector2* multiplier);
	
	virtual Vector2* multiply(float multiplier);
	virtual Vector2* operator*(float multiplier);
	
	virtual Vector2* normalize(void);
};
