/*   DatagramPacket NX  Ver 0.01   */
/*                                     */
/*                                     */
/*   by toyo    1999/3/15              */

#include "basic.h"
#include "NetworkException.h"
#include "InetAddress.h"
#include "DatagramPacket.h"
#include <stdio.h>

DatagramPacket::DatagramPacket(BYTE *data,int dataSize,int length){
	this->data=data;
	this->dataSize=dataSize;
	this->length=length;
	
	LPSOCKADDR_IN lpSocketAddress=(LPSOCKADDR_IN)malloc(sizeof(SOCKADDR_IN));
	memset(lpSocketAddress,0,sizeof(SOCKADDR_IN));
	this->inetAddress=new InetAddress(lpSocketAddress);
}

DatagramPacket::DatagramPacket(
	BYTE *data,int dataSize,int length,
	InetAddress *inetAddress,int port){
	
	this->data=data;
	this->dataSize=dataSize;
	this->length=length;
	this->inetAddress=inetAddress;
	this->inetAddress->lpSocketAddress->sin_port=htons(port);
}

DatagramPacket::~DatagramPacket(){
	//delete inetAddress;
}

InetAddress* DatagramPacket::getAddress(){
	return inetAddress;
}

int DatagramPacket::getPort(){
	return ntohs(this->inetAddress->lpSocketAddress->sin_port);
}

BYTE* DatagramPacket::getData(){
	return data;	
}

int DatagramPacket::getLength(){
	return length;
}

void DatagramPacket::setAddress(InetAddress *inetAddress){
	this->inetAddress=inetAddress;
}

void DatagramPacket::setPort(int port){
	this->inetAddress->lpSocketAddress->sin_port=htons(port);
}

void DatagramPacket::setData(BYTE *data){
	this->data=data;
}

void DatagramPacket::setLength(int length){
	this->length=length;
}
