/*   DatagramSocket NX  Ver 0.00   */
/*                                     */
/*                                     */
/*   by Toyonori    1999/3/15          */

class InetAddress;
class DatagramPacket;
class NetworkException;

class DatagramSocket:public Object{
private:
	SOCKET sock;
	
	InetAddress *localAddress;
	LPSOCKADDR_IN lpSocketAddress;
	
	WSABUF wsabuf;
	DWORD dwFlags;
	DWORD dwRecvd;
	WSAOVERLAPPED overlapped;
	DatagramPacket *unreadDatagramPacket;
	
	void initInstance();
public:
	DatagramSocket() throw (NetworkException*);
	DatagramSocket(int) throw (NetworkException*);
	DatagramSocket(int,InetAddress*) throw (NetworkException*);
	
	virtual ~DatagramSocket();

	void close() throw (NetworkException*);
	InetAddress *getLocalAddress();
	int getLocalPort();
	void send(DatagramPacket *) throw (IOException*);
	boolean receive(DatagramPacket *) throw (IOException*);
	boolean isReceived() throw (IOException*);
	//int getSoTimeout();
	//void setSoTimeout();
};

