/*   InetAddressManager NX  Ver 0.00   */
/*                                         */
/*                                         */
/*   by toyo    1999/4/29                  */

class InetAddress;
class NetworkException;

class InetAddressManager:public Object{
private:
	InetAddress *inetAddressByName;
	InetAddress **inetAddressAllByName;
	InetAddress *localHost;
	
	boolean isGetByName;
	boolean isGetAllByName;
	boolean isGetLocalHost;
public:
	InetAddressManager();
	virtual ~InetAddressManager();
	
	virtual boolean getByName(String*,InetAddress*) throw (NetworkException*);
	virtual boolean getAllByName(String*,InetAddress**) throw (NetworkException*);
	virtual boolean getLocalHost(InetAddress*) throw (NetworkException*);
	
	virtual boolean isCompleteGetByName() throw (NetworkException*);
	virtual boolean isCompleteGetAllByName() throw (NetworkException*);
	virtual boolean isCompleteGetLocalHost() throw (NetworkException*);
	
	virtual void cancelGetByName() throw (NetworkException*);
	virtual void cancelGetAllByName() throw (NetworkException*);
	virtual void cancelGetLocalHost() throw (NetworkException*);
};
