/*   NetSpecAnalyzer NX  Ver 0.00  */
/*                                     */
/*                                     */
/*   by toyo    1999/11/11             */

class IOException;
class InputStream;
class OutputStream;
class NetSpec;
class Socket;

class NetSpecAnalyzer:Object{
	private:
	
	Socket *socket;
	InputStream *in;
	OutputStream *out;

	void read(byte *buffer,int off,int len) throw (IOException*);
	void write(byte *buffer,int off,int len) throw (IOException*);
	
	public:
	
	static const int TCP_BANDWIDTH_CHECK_SIZE;
	static const int TCP_RESPONSE_CHECK_SIZE;
	static const int TCP_RESPONSE_CHECK_TIMES;
	
	NetSpecAnalyzer(Socket *socket);
	virtual void serveTCPResponse() throw (IOException*);
	virtual double getTCPResponse() throw (IOException*);
	virtual void serveTCPBandWidth() throw (IOException*);
	virtual double getTCPBandWidth() throw (IOException*);
	
	virtual NetSpec *getNetSpec() throw (IOException*);
	virtual void serveNetSpec() throw (IOException*);
};

