/*   Socket NX       Ver 0.00   */
/*                                  */
/*                                  */
/*   by Toyonori    1999/4/25       */

//#include "TCPInputStream.h"
//#include "TCPOutputStream.h"

class InetAddress;
class InputStream;
class OutputStream;
class TCPInputStream;
class TCPOutputStream;
class NetworkException;

class Socket:public Object{
  private:
	SOCKET sock;
	InetAddress *inetAddress;
	int portNum;
	InetAddress *localAddress;
	int localPortNum;
	TCPInputStream *tcpInputStream;
	TCPOutputStream *tcpOutputStream;
	
	HANDLE hEventObject;
	boolean isConnectionComplete;
	
	void initInstance(InetAddress *inetAddress,int portNum) throw (NetworkException*);
	void initLocalPort(void) throw (NetworkException*);
  public:
    //RXgN^
    Socket(InetAddress*,int) throw (NetworkException*);
    //Socket(InetAddress*,int,InetAddress*,int);
    //Socket(String*,int) throw (NetworkException);
    //Socket(char*,int,InetAddress*,int);
    
	virtual ~Socket();
	
    //o֐
    virtual void close() throw (NetworkException*);
	
	virtual void makeConnection() throw (NetworkException*);
	virtual boolean isConnected() throw (NetworkException*);
	
	virtual InetAddress* getInetAddress();
    virtual InputStream* getInputStream() throw (IOException*);
	virtual OutputStream* getOutputStream() throw (IOException*);
	virtual boolean isSendBufferEmpty();

    virtual InetAddress* getLocalAddress();
    virtual int getLocalPort();
    virtual int getPort();
    //int getSoLinger();
    //int getSoTimeout();
    //boolean getTcpNoDelay();
    //void setSoLinger(int);
    //void setSoTimeout(int);
    //void setTcpNoDelay(boolean);
};

