/*   TCPOutputStream NX Ver 0.00 */
/*                                   */
/*                                   */
/*   by Toyonori    1999/3/8         */

class OutputStream;
class IOException;

class TCPOutputStream:public OutputStream{
public:
	static const int SLEEP_TIME;
	static const int BLOCK_SIZE;
private:
    TCPOutputStream(SOCKET) throw (IOException*);	
	TCPOutputStream(SOCKET,DWORD) throw (IOException*);
	void initInstance(SOCKET,DWORD) throw (IOException*);
	
	SOCKET sock;
	
	WSABUF wsabuf;
	BYTE *buffer;
	DWORD bufferSize;
	DWORD initialBufferSize;
	
	BYTE *subBuffer;
	DWORD subBufferIndex;
	DWORD subBufferSent;	
	DWORD subBufferOffset;

	WSAOVERLAPPED overlapped;
	DWORD dwFlags;
	DWORD dwSent;
	
	boolean isCalledWSASend;
	
	void changeSubBufferSize(DWORD newSubBufferSize);
	
	virtual boolean send() throw (IOException);
	virtual boolean isSent() throw (IOException);
	
	friend class Socket;
	//
	//virtual void writeSub(BYTE[],int,int) throw (IOException*);
  public:
	virtual ~TCPOutputStream();
    virtual void write(BYTE) throw (IOException*);
	virtual void write(BYTE[],int,int) throw (IOException*);
	virtual void flush() throw (IOException*);
	
	virtual boolean isSendBufferEmpty();
};

