/* SoundData NX	 Ver 0.00		*/
/*									*/
/*									*/
/*	 by toyo		1999/5/2		*/

class Serializable;
class ObjectInputStream;
class ObjectOutputStream;

class SoundBuffer;
class WaveFormat;

class SoundData:public Object,public Serializable{
public:
	SoundBuffer *soundBuffer;
	WaveFormat *waveFormat;
	
	LPDIRECTSOUNDBUFFER lpDirectSoundBuffer;
	
	int duplicateSoundNum;
	LPDIRECTSOUNDBUFFER *lpDirectSoundBufferArray;
	
	boolean isStaticSound;
	boolean firstPlay;

	SoundData(void);
	SoundData(SoundBuffer*,WaveFormat *);
	SoundData(SoundBuffer*,WaveFormat *,int duplicateSoundNum);
	~SoundData(void);
	
	SoundData *clone(void);

	virtual boolean isStatic(void);
	virtual void setStatic(boolean isStaticSound);
	
	virtual boolean isFirstPlay(void);
	virtual void setFirstPlay(boolean firstPlay);
	
	virtual int getDuplicateSoundNum(void);
	virtual LPDIRECTSOUNDBUFFER getDirectSoundBuffer(int index);
	virtual void setDirectSoundBuffer(LPDIRECTSOUNDBUFFER lpDirectSoundBuffer,int index);
	
	virtual SoundBuffer *getSoundBuffer(void);
	virtual WaveFormat *getWaveFormat(void);
	virtual LPDIRECTSOUNDBUFFER getDirectSoundBuffer(void);
	
	static SoundData* newInstance(int id);
	virtual int getTypeID(void);
	virtual void readObject(ObjectInputStream* in);
	virtual void writeObject(ObjectOutputStream* out);
};