/* WaveFileLoader NX	Ver 0.00		*/
/*																		*/
/*																		*/
/*	 by toyo		1999/5/2							*/

class IOException;
class FileNotFoundException;
class InputStream;
class FileInputStream;

class WaveFileLoader:public Object{
private:
	enum ERROR_CODE
	{
		SUCCEED,
		ERR_WAVE_OPEN_FAILED,
		ERR_WAVE_INVALID_FORMAT,
		ERR_CREATEDSB_FAILED,
		ERR_WAVE_CORRUPTED_FILE,
		ER_CANNOTOPEN,
		ER_NOTWAVEFILE,
		ER_CANNOTREAD,
		ER_MEM,
		ER_CORRUPTWAVEFILE
	};
	
	static int WaveOpenFile(
		char *pszFileName,			// (IN)
		HMMIO *phmmioIn,			// (OUT)
		WAVEFORMATEX **ppwfxInfo,	// (OUT)
		MMCKINFO *pckInRIFF			// (OUT)
	);
	
	static int WaveStartDataRead(
		HMMIO *phmmioIn,			// (IN)
		MMCKINFO *pckIn,			// (IN)
		MMCKINFO *pckInRIFF			// (IN)
	);
	
	static int WaveReadFile(
		HMMIO hmmioIn,				// (IN)
		UINT cbRead,				// (IN)
		BYTE *pbDest,				// (IN)
		MMCKINFO *pckIn,			// (IN)
		UINT *cbActualRead			// (OUT)
	);
	
	static int WaveLoadFile(
		char *pszFileName,			// (IN)
		UINT *cbSize,				// (OUT)
		DWORD *pcSamples,			// (OUT)
		WAVEFORMATEX **ppwfxInfo,	// (OUT)
		BYTE **ppbData				// (OUT)
	);
	
	static int WaveCloseReadFile(
			HMMIO *phmmio,			// (IN)
			WAVEFORMATEX **ppwfxSrc	// (IN)
	);
public:
	static SoundData *readWaveFile(String *fileName) throw (IOException*);
	static SoundData *readWaveFile(String *fileName,int duplicateSoundNum) throw (IOException*);
};

