/* WaveformAudioRecorder NX  Ver 0.00  */
/*                                         */
/*                                         */
/*   by toyo    1999/4/8                   */

class SoundBuffer;

class WaveformAudioRecorder:public SoundRecorder{
private:
	SoundBuffer *soundBuffer;
	SoundBuffer *subBuffer;

	HWAVEIN hWaveIn;
	WAVEHDR *waveHeader;
	
	DWORD currentBlockNo;
	
	boolean isCompressionMode;
	DWORD dwCompressionRate;
	
	void initInstance(
		HWAVEIN hWaveIn,
		boolean isCompressionMode,
		DWORD dwCompressionRate,
		SoundBuffer *soundBuffer
	);
public:
	WaveformAudioRecorder(
		HWAVEIN hWaveIn,
		SoundBuffer *soundBuffer
	);
	
	WaveformAudioRecorder(
		HWAVEIN hWaveIn,
		DWORD dwCompressionRate,
		SoundBuffer *soundBuffer
	);
	
	virtual ~WaveformAudioRecorder();
	
	virtual boolean start();
	virtual boolean processRecording();
	virtual boolean isProcessReady();
	virtual boolean stop();
	
	virtual int getPastBlockNo();
	virtual int getCurrentBlockNo();
};

