/*   nbV\          Ver 0.20   */
/*                                  */
/*                                  */
/*   by Atsushi          1999/9/8   */
/*   by Y.Hayashi       1999/6/27   */


/*   ---   RXgN^   ---   */

template <class Type> HashtableEnumeration<Type>::
    HashtableEnumeration(Type** elements,int size)
{
	this->elements=elements;
	this->size    =size;
	
	pointer=0;
}


/*   ---      ---   */

template <class Type> boolean HashtableEnumeration<Type>::hasMoreElements(void)
{
	return (pointer<size);
}

template <class Type> Type* HashtableEnumeration<Type>::nextElement(void)
{
	return elements[pointer++];
}


/*   ---   fXgN^   ---   */

template <class Type> HashtableEnumeration<Type>::~HashtableEnumeration(void)
{
	delete[] elements;
}
