/*   obt@  Ver 0.00   */
/*                              */
/*                              */
/*   by Atsushi      1999/6/2   */


#include "basic.h"

#include <string.h>

#include "StringBuffer.h"


/*   ---   RXgN^   ---   */

StringBuffer::StringBuffer(void)
{
	capacity=1;
	elements=new char[capacity];
	size=0;
}


/*   ---      ---   */

int StringBuffer::length(void)
{
	return size;
}

String* StringBuffer::toString(void)
{
	char* str;

	str=new char[size+1];
	for (int i=0;i<=size-1;i++)
	{
		str[i]=elements[i];
	}
	str[size]=NULL;
	
	return new String(str,TRUE);
}


/*   ---   ǉ   ---   */

void StringBuffer::append(char value)
{
	char* old;

	if (size+1>capacity)
	{
		old=elements;
		capacity*=2;
		
		elements=new char[capacity];
		for (int i=0;i<=size-1;i++)
		{
			elements[i]=old[i];
		}
		
		delete[] old;
	}
	
	elements[size]=value;
	
	size++;
}

void StringBuffer::append(String* value)
{
	for (int i=0;i<=value->length()-1;i++) append(value->charAt(i));
}

void StringBuffer::append(char* value)
{
	for (int i=0;value[i]!=NULL;i++) append(value[i]);
}


/*   ---      ---   */

void StringBuffer::clear(void)
{
	size=0;
}


/*   ---   fXgN^   ---   */

StringBuffer::~StringBuffer(void)
{
	delete[] elements;
}
